
#include <stdio.h>

struct Point3D {
  double x;
  double y;
  double z;
};
typedef struct Point3D p3d_t;

void init_pt(p3d_t * pt, double x, double y, double z) {
  pt->x = x;
  pt->y = y;
  pt->z = z;
}

void print_pt(p3d_t * pt) {
  printf("\n[%g,%g,%g]",pt->x,pt->y,pt->z);
}

/* This is a fine place for your 4 functions */

void midpoint_test() {
  p3d_t pts[6];
  init_pt(&pts[0], 1.0, 2.0, 3.0);
  init_pt(&pts[1], 4.0, 9.0, -7.5);
  pts[2] = midpoint1(pts[0],pts[1]);
  midpoint2(&pts[3],&pts[0],&pts[1]);
  pts[4] = midpoint3(pts[0],pts[1]);
  midpoint4(&pts[5],&pts[0],&pts[1]);
  int i=0;
  for(; i < 6; ++i)
    print_pt(&pts[i]);
  printf("\n");
}

int main(int argc, char**argv) {
  midpoint_test();
  return 0;
}
